var idCache = {};
var idCounter = 0;
var typeFolder = 0;
var typeString = 1;
var typeInteger = 2;
var typeBoolean = 3;

var data = [];

function recToggle(parent, id) {
	for ( var i = 0; i < parent.length; i++) {
		var object = parent[i];
		if (object.domID == id) {
			object.value = !object.value;
			if (object.notDownloaded) {
				object.children = getPropertyChildren(object.absolutePath);
				object.notDownloaded = false;
			}
		}
		if (object.children != null)
			recToggle(object.children, id);
	}

}

function toggleNode(id) {
	recToggle(data, id);
	refresh();
}

function getRecObject(parent, id) {
	for ( var i = 0; i < parent.length; i++) {
		var object = parent[i];
		if (object.domID == id)
			return object;
		if (object.children != null) {
			var child = getRecObject(object.children, id);
			if (child != null)
				return child;
		}
	}
	return null;
}

function getObject(id) {
	return getRecObject(data, id);
}

function newString2Enter(e,id)
{
	if (e.keyCode == 13) {
		newString2(id);
	}
}
function newBool2Enter(e,id)
{
	if (e.keyCode == 13) {
		newBool2(id);
	}
}
function newInt2Enter(e,id)
{
	if (e.keyCode == 13) {
		newInt2(id);
	}
}

function newFolder2Enter(e,id)
{
	if (e.keyCode == 13) {
		newFolder2(id);
	}
}

function getPathRecObject(parent, path) {
	for ( var i = 0; i < parent.length; i++) {
		var object = parent[i];
		if (object.absolutePath == path)
			return object;
		if (object.children != null) {
			var child = getPathRecObject(object.children, path);
			if (child != null)
				return child;
		}
	}
	return null;
}

function getObjectPerPath(path)
{
	return getPathRecObject(data,path);
}

function newString2(id) {
	var object = getObject(id);
	var oText = document.getElementById('newStringControl_' + id);
	if (oText.value != "") {
		if (object.children == null)
			object.children = [];
		object.children.push({
			absolutePath : object.absolutePath + '/' + oText.value,
			value : '',
			name : oText.value,
			type : typeString
		});
		setProperty(object.absolutePath + '/' + oText.value, '');
	}
	refresh();
	startEdit(getObjectPerPath(object.absolutePath + '/' + oText.value).domID);
}

function newString(id) {
	var oSpan = document.getElementById('newString_' + id);
	oSpan.innerHTML = 'Name: <input type="text" onblur="newString2(\'' + id
			+ '\')" onkeypress="newString2Enter(event,\'' + id
			+ '\')" id="newStringControl_' + id + '">'
	oSpan.onclick = null
	oSpan = document.getElementById('newBool_' + id);
	oSpan.innerHTML = '';
	oSpan = document.getElementById('newInt_' + id);
	oSpan.innerHTML = '';
	oSpan = document.getElementById('newFolder_' + id);
	oSpan.innerHTML = '';
	document.getElementById('newStringControl_' + id).focus();
}

function newInt2(id) {
	var object = getObject(id);
	var oText = document.getElementById('newIntControl_' + id);
	if (oText.value != "") {
		if (object.children == null)
			object.children = [];
		object.children.push({
			absolutePath : object.absolutePath + '/' + oText.value,
			value : 0,
			name : oText.value,
			type : typeInteger
		});
		setProperty(object.absolutePath + '/' + oText.value, 0);
	}
	refresh();
	startEdit(getObjectPerPath(object.absolutePath + '/' + oText.value).domID);
}

function newInt(id) {
	var oSpan = document.getElementById('newInt_' + id);
	oSpan.innerHTML = 'Name: <input type="text" onblur="newInt2(\'' + id
			+ '\')" onkeypress="newInt2Enter(event,\'' + id
			+ '\')" id="newIntControl_' + id + '">'
	oSpan.onclick = null
	oSpan = document.getElementById('newBool_' + id);
	oSpan.innerHTML = '';
	oSpan = document.getElementById('newString_' + id);
	oSpan.innerHTML = '';
	oSpan = document.getElementById('newFolder_' + id);
	oSpan.innerHTML = '';
	document.getElementById('newIntControl_' + id).focus();
}

function newBool2(id) {
	var object = getObject(id);
	var oText = document.getElementById('newBoolControl_' + id);
	if (oText.value != "") {
		if (object.children == null)
			object.children = [];
		object.children.push({
			absolutePath : object.absolutePath + '/' + oText.value,
			value : false,
			name : oText.value,
			type : typeBoolean
		});
		setProperty(object.absolutePath + '/' + oText.value, false);
	}
	refresh();
	startEdit(getObjectPerPath(object.absolutePath + '/' + oText.value).domID);
}

function newBool(id) {
	var oSpan = document.getElementById('newBool_' + id);
	oSpan.innerHTML = 'Name: <input type="text" onblur="newBool2(\'' + id
			+ '\')" onkeypress="newBool2Enter(event,\'' + id
			+ '\')" id="newBoolControl_' + id + '">'
	oSpan.onclick = null
	oSpan = document.getElementById('newInt_' + id);
	oSpan.innerHTML = '';
	oSpan = document.getElementById('newString_' + id);
	oSpan.innerHTML = '';
	oSpan = document.getElementById('newFolder_' + id);
	oSpan.innerHTML = '';
	document.getElementById('newBoolControl_' + id).focus();
}

function newFolder2(id) {
	var object = getObject(id);
	var oText = document.getElementById('newFolderControl_' + id);
	if (oText.value != "") {
		if (object.children == null)
			object.children = [];
		object.children.push({
			absolutePath : object.absolutePath + '/' + oText.value,
			value : false,
			name : oText.value,
			type : typeFolder,
			children:null,
			notDownloaded:true
		});
		setProperty(object.absolutePath + '/' + oText.value+'/_dummy', '_dummy');
	}
	refresh();
}

function newFolder(id) {
	var oSpan = document.getElementById('newFolder_' + id);
	oSpan.innerHTML = 'Name: <input type="text" onblur="newFolder2(\'' + id
			+ '\')" onkeypress="newFolder2Enter(event,\'' + id
			+ '\')" id="newFolderControl_' + id + '">'
	oSpan.onclick = null
	oSpan = document.getElementById('newBool_' + id);
	oSpan.innerHTML = '';
	oSpan = document.getElementById('newString_' + id);
	oSpan.innerHTML = '';
	oSpan = document.getElementById('newInt_' + id);
	oSpan.innerHTML = '';
	document.getElementById('newFolderControl_' + id).focus();
}

var editNode = null;

function endEdit() {
	var oData = getObject(editNode);
	var oDocumentObject = document.getElementById(editNode);
	var editControl = document.getElementById("editField");
	if (oData.type == typeString) {
		oData.value = editControl.value;
		setProperty(oData.absolutePath, "" + oData.value);
	}
	if (oData.type == typeString) {
		oData.value = editControl.value;
		setProperty(oData.absolutePath, "" + oData.value);
	}
	if (oData.type == typeInteger) {
		oData.value = parseInt(editControl.value, 10);
		setProperty(oData.absolutePath, oData.value);
	}
	if (oData.type == typeBoolean) {
		oData.value = editControl.checked;
		setProperty(oData.absolutePath, oData.value);
	}
	oDocumentObject.innerHTML = oData.value;
	editNode = null;
}

function endEnterKey(e)
{
	if (e.keyCode == 13) {
		endEdit();
	}
}

function startEdit(id) {
	if (editNode != null) {
		if (editNode == id)
			return;
		endEdit();
	}
	var oData = getObject(id);
	var oDocumentObject = document.getElementById(id);
	if ((oData.type == typeString) || (oData.type == typeInteger)) {
		document.getElementById(id).innerHTML = '<input id="editField" type="text" value="'
				+ oData.value + '" onblur="endEdit();" onkeypress="endEnterKey(event);">';
		editNode = id;
		document.getElementById('editField').focus();
	} else if (oData.type == typeBoolean) {
		if (oData.value)
			document.getElementById(id).innerHTML = '<input id="editField" type="checkbox" selected>';
		else
			document.getElementById(id).innerHTML = '<input id="editField" type="checkbox">';
		editNode = id;
		document.getElementById('editField').focus();
	}
}

function deleteRecNode(id,parent)
{
	for ( var i = 0; i < parent.length; i++) {
		var object = parent[i];
		if (object.domID == id) {
			parent.splice(i,1);
			return;
		}
			
		if (object.children != null) {
			deleteRecNode(id,object.children);
		}
	}
}

function deleteNode(id)
{
	var object = getObject(id);
	if (confirm('Knoten - ' + object.absolutePath + ' - lschen ?')) {
		removeProperty(object.absolutePath);
		deleteRecNode(id,data);
		refresh();
		
	}
}

// node: {absolutePath,value,name,type,children}
function renderNode(nodes, parentID) {
	var sString = '<table cell class="tree" cellpadding="0" style="width:100%;" cellspacing="0">';
	var childToWork = [];
	if (nodes != null)
		for ( var iIndex = 0; iIndex < nodes.length; iIndex++) {
			var object = nodes[iIndex];
			var fOpenKnoten = false;
			if (object.type == typeFolder)
				if (object.value)
					fOpenKnoten = true;

			
			var sFunction = "";
			if (object.type == typeFolder)
				sFunction = "toggleNode('note_" + idCounter + "');";

			if (fOpenKnoten == false) {
				sString += '<tr style="padding-top: 3px;" ><td style="padding-right: 3px;" onclick=' + sFunction + '>';
				if (object.type == typeString)
					sString += '<img src="string.png">';
				if (object.type == typeInteger)
					sString += '<img src="integer.png">';
				if (object.type == typeBoolean)
					sString += '<img src="boolean.png">';
				if (object.type == typeFolder)
					sString += '<img src="folder.png">';
				sString += '</td><td onclick="' + sFunction + '" style="padding-right: 3px;"><b>';
				sString += object.name;
				sString += ' </b></td><td style="width:100%;" id="note_' + idCounter + '"'
				if (object.type == typeString)
					sString += 'onclick="startEdit(\'note_' + idCounter
							+ '\');" colspan="2">' + object.value;
				if (object.type == typeInteger)
					sString += 'onclick="startEdit(\'note_' + idCounter
							+ '\');" colspan="2">' + object.value;
				if (object.type == typeBoolean)
					sString += 'onclick="startEdit(\'note_' + idCounter
							+ '\');" colspan="2">' + object.value;

				if (object.type == typeFolder)
					sString += '  colspan="2">(' + object.absolutePath + ')';
				sString += '</td><td style="width:24px;"><img src="refresh.png" onclick="refreshNode(\'note_' + idCounter
				+ '\')"></td><td style="width:24px;"><img src="delete.png" style="padding-left: 4px;" onclick="deleteNode(\'note_' + idCounter
				+ '\');"></td></tr>';
				
			} else {
				sString += '<tr style="padding-top: 3px;"><td style="padding-right: 3px;" onclick=' + sFunction
						+ '><img src="folder_open.png"></td><td style="padding-right: 3px;" onclick=' + sFunction + '><b>';
				sString += object.name;
				sString += '</b></td><td style="padding-right: 3px;"><table cellpadding="0" style="vertical-align:middle;" cellspacing="0"><tr style="padding-top: 5px;">';
				sString += '<td onclick="newString(\'note_' + idCounter
						+ '\');" id="newString_note_' + idCounter
						+ '"><img src="add.png"> String</td> ';
				sString += '<td onclick="newInt(\'note_' + idCounter
						+ '\');" id="newInt_note_' + idCounter
						+ '"><img src="add.png"> Integer</td> ';
				sString += '<td onclick="newBool(\'note_' + idCounter
						+ '\');" id="newBool_note_' + idCounter
						+ '"><img src="add.png"> Bool</td> ';
				sString += '<td onclick="newFolder(\'note_' + idCounter
						+ '\');" id="newFolder_note_' + idCounter
						+ '"><img src="add.png"> Folder</td></tr></table><td>(';
				sString += object.absolutePath;
				sString += ')</td>';
				
				sString += '</td><td style="width:24px;"><img src="refresh.png" onclick="refreshNode(\'note_' + idCounter
				+ '\')"></td><td style="width:24px;"><img src="delete.png" style="padding-left: 4px;" onclick="deleteNode(\'note_' + idCounter
				+ '\');"></td><tr>';
				sString += '<tr><td></td><td id="note_' + idCounter
						+ '" colspan="5">';
				sString += '</td></tr>';
				childToWork.push({
					id : 'note_' + idCounter,
					ob : object.children
				});
			}
			object.domID = 'note_' + idCounter;
			idCounter++;
		}
	sString += "</table>"
	document.getElementById(parentID).innerHTML = sString;
	for ( var iIndex = 0; iIndex < childToWork.length; iIndex++) {
		renderNode(childToWork[iIndex].ob, childToWork[iIndex].id);
	}

}

function refresh() {
	renderNode(data, 'content');
}

function initValues() {
	login();
	data = getPropertyChildren('/');
	refresh();

}

function getPropertyChildren(parentpath) {
	var sURL = '/json/property/getChildren';
	var sPfad = escape(parentpath);
	var sReturnStruct = ajaxSyncRequest(sURL, {
		'path' : sPfad
	});
	sURL = '/json/property/query';
	var sReturnQuery = ajaxSyncRequest(sURL, {
		'query' : sPfad + '(*)'
	});

	var obj = eval('(' + sReturnStruct + ')');
	var value = eval('(' + sReturnQuery + ')');
	if ((obj.ok) || (value.ok)) {
		var resultObject = [];
		for ( var iIndex = 0; iIndex < obj.result.length; iIndex++) {
			var res = {};
			var ooo = obj.result[iIndex];
			if (parentpath.length == 1) {
				res.absolutePath = parentpath + ooo.name;
				res.name = ooo.name;
			} else {
				res.absolutePath = parentpath + '/' + ooo.name;
				res.name = ooo.name;
			}
			res.type = typeString;
			if (ooo.type == 'integer')
				res.type = typeInteger;
			if (ooo.type == 'none')
				res.type = typeFolder;

			if (res.type != typeFolder) {
				for ( var objKey in value.result) {
					var oInhalt = value.result[objKey];
					if (oInhalt[0][res.name] != null)
						res.value = oInhalt[0][res.name];
				}
			} else {
				res.value = false;
				res.notDownloaded = true;
			}
			resultObject.push(res);
		}
		return resultObject;
	} else
		return null;
}

function refreshNode(id)
{
	var object = getObject(id);
	if (object.type==typeString)
		object.value=getPropertyString(object.absolutePath);
	if (object.type==typeInteger)
		object.value=getPropertyInteger(object.absolutePath);
	if (object.type==typeBoolean)
		object.value=getPropertyBoolean(object.absolutePath);
	if (object.type==typeFolder)
	{
		var fShouldBeToogled=object.value;
		object.value = false;
		object.notDownloaded = true;
		object.children=null;
		if (fShouldBeToogled)
			toggleNode(id);
	}
	
	refresh();
}